var lodash = require('lodash'),
    _ = {},
    fs = require('fs-extra'),
    path = require("path"),
    glob = require("glob");

_.camel = function (str, split) {
    split = split || "/";
    var d = str.split(split);
    str = d[0];
    for (i = 1; i < d.length; i++) {
        str += d[i][0].toUpperCase() + d[i].substring(1)
    }
    return str;
};

lodash.extend(_,lodash);

Date.prototype.Format = function (fmt) { //author: meizz
    var o = {
        "M+": this.getMonth() + 1,                 //月份
        "d+": this.getDate(),                    //日
        "h+": this.getHours(),                   //小时
        "m+": this.getMinutes(),                 //分
        "s+": this.getSeconds(),                 //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};

_.log = function (level,info) {
    info = `${new Date().Format("[yyyy-MM-dd hh:mm:ss]").white}[${levelMap[level]}] ${info.white}`;
    if(light.config.log){
        light.config.log(info)
    }else{
        console.log.apply(this,[info]);
    }
};

let levelMap = {
    "error":"ERROR".red,
    "info":"INFO".white,
    "warn":"WARN".yellow,
};
_.log2 = function (level, logKey,...source) {
    let originText = require("./log/logger")(logKey,source);
    let info = `${new Date().Format("[yyyy-MM-dd hh:mm:ss]").white}[${levelMap[level]}] ${originText}`;
    if(light.config.log){
        light.config.log(info)
    }else{
        console.log.apply(this,[info]);
    }
};

lodash.extend(_,fs);

_.join = path.join;
_.parse = path.parse;
_.glob = glob;

_.require=function (module) {
    return require(module);
}

let archiver = require('archiver');
_.zipDir = function zipDir(dir, dist,config) {
    return new Promise(function (resolve, reject) {
        _.remove(dist, function () {
            let output = _.createWriteStream(dist);
            let archive = archiver('zip');

            output.on('close', function () {
                _.log2("info", "packager.stop" ,dist,archive.pointer());
                resolve(dist);
            });

            archive.on('error', function (err) {
                throw err;
            });

            archive.pipe(output);

            let files = _.glob.sync(dir + "/**/*",{
                ignore:(config&&config.exclude&&config.exclude.packager?config.exclude.packager:[]).map((data)=>{
                    return `${dir}/${data}`
                })
            });
            files.forEach(function (file) {
                file = require("path").normalize(file);
                if (_.statSync(file).isFile()) archive.append(_.createReadStream(file), {name: file.replace(dir, "")})
            });

            archive.finalize();
        });
    })
};

_.openURL = function (url) {
    let exec = require('child_process').exec,
        cmd;
    switch (process.platform) {
        case 'win32':
            cmd = 'start';
            break;

        case 'linux':
            cmd = 'xdg-open';
            break;

        case 'darwin':
            cmd = 'open';
            break;
    }
    exec(`${cmd} ${url}`);
};

/**
 * 打开浏览器
 */
_.getIPAdress = function () {
    var ip = '';
    var interfaces = require('os').networkInterfaces();
    for (var devName in interfaces) {
        var iface = interfaces[devName];
        for (var i = 0; i < iface.length; i++) {
            if (ip == '') {
                var alias = iface[i];
                if (alias.family === 'IPv4' && alias.address !== '127.0.0.1' && !alias.internal) {
                    ip = alias.address;
                    continue;
                }
            }

        }
    }
    if (ip == '') {
        ip = 'localhost';
    }
    return ip;
}

module.exports = _;

