/**
 * -- 同步调用demo --
 * 
 * 使用说明：
 * 此功能依赖asyncawait模块 ，使用前必须单独安装，模块不包含在light-api模块中
 * await()返回promise.resolve()的数据后可以同步调用
 * await必须在async包装函数中执行
 * 
 */

const Joi = require('joi');
let async = require('asyncawait/async');
let await = require('asyncawait/await');

module.exports = {
    method: 'POST',
    path: '/demo/async',
    config: {
        description: 'async,await使用demo',
        validate: {
            payload: {
                compentId: Joi.number().integer().required()
            }
        }
    },

    handler: function (request, reply) {
        
        var compentId = request.payload.compentId;

        var rdb = this.getPlugin('light-api-mysql');

        /* 
            整个查询都在async异步执行代码中，
        */
        var query = async(function () {

            var appInfo = await (rdb.query('SELECT * FROM lt_app where id =? order by create_date DESC', compentId))
            var leaseList = await(rdb.query('SELECT * FROM lt_lease where app_id =? order by create_date DESC', compentId))
            return {
                app: appInfo,
                inst: leaseList
            }
        });

        /* 
            建议在query中 return,
            在query.then()中统一处理 reply
        */
        query()
        .then(function(data){
            reply.data(data);
        })
        .catch(function(err){
            // doSth
        })
    }
}