/**
 * -- 获取文件元数据 --
 * 
 * 使用说明：
 * 使用前需要在./config目录中引入light-api-mongo插件，同时配置db.json文件。插件包含在light-api模块中。
 * 获取文件元数据，以文件存储在mongoDb的GridFS中为例子;
 */



const Joi =  require('joi');
module.exports={
    method:'GET',
    path:'/demo/file/getFileMeta',
    config:{
         description: '根据文件id获取文件元数据',
         tags: ['api'],
          validate: {
          query:{
             fileId:Joi.string().required()
          }
      }  
    },
    handler:function(request,reply){
        //获取日志对象
        let logger = this.getLogger(__filename);
        //获取参数
        let params = request.query;

        //从mongoDb插件
        let sdb =  this.getPlugin('light-api-mongo');
        //获取文件元数据api
        sdb.getFileMetadata(params.fileId)
        .then(function(result){
            logger.info(result);
            return reply.data(result);
        }).catch(function(err){
            logger.info(err);
            return reply.err('请求错误');
        })
    }
}