/**
 * -- mongoDB使用api --
 * 
 * 使用说明：
 * 使用前需要在./config目录中引入light-api-mongo插件，同时配置db.json文件。插件包含在light-api模块中。
 * mongoDb使用api
 */



module.exports={
    method:'GET',
    path:'/demo/mongodemo',
    config:{
        description: 'light-api-mongo插件demo'
    },
    handler:function(request,reply){

        //获取light-api-mysql插件服务,必须在/config/config.js中引入插件
        let sdb = this.getPlugin('light-api-mongo');

        // (1)默认数据库的query，insert，update，remove 方法
        //query方法 查找默认db的集合
            sdb.query('integration',{_id:'56c2edb02c5a4e78577632c9'})
            .then(function(result){
                reply.data(result);
            }).catch(function(err){
                reply.err('执行错误');
            });

        //insert方法 插入默认db的integration集合一条文档
            // sdb.insert('integration',{name:'cc',age:23,job:'project'})
            //    .then(function(result){
            //         return reply.data(result); //返回插入数据_id,-->5950a1c4fa7a0a2b102869d1
            //     }).catch(function(err){
            //         return reply.err('执行错误')
            //     });

        //update方法 更新默认db的integration集合的文档

            // sdb.update('integration','5950a1c4fa7a0a2b102869d1',{name:'vv'})
            //    .then(function(result){
            //       return reply.data(result);
            //    }).catch(function(err){
            //       return reply.err('执行错误')
            //    });

        //remove方法 删除指定文档
            //  sdb.remove('integration',"5950a1c4fa7a0a2b102869d1")
            //     .then(function(result){
            //        return reply.data(result);
            //     }).catch(function(err){
            //        return reply.err('执行错误')
            //     })


        //分页查询
            /**
             * 分页查询
             * @param {*} collectionName ：集合名 eg "integration"
             * @param {*} where ：查询条件 {}
             * @param {*} sort ：排序条件 {create_date:-1}
             * @param {*} pageParam ：分页参数 eg {pageNo:1,pageSize:10} 
             */

            // sdb.queryListPage('integration',{},{create_date:-1},{pageNo:1,pageSize:10})
            // .then(function(result){
            //      return reply.data(result);
            // }).catch(function(err){  
            //     console.log(err); 
            //     return reply.err('执行错误');
            // });

        //获取文档条数
            /**
             * 查询总数
             * @param {*} collectionName ：集合名
             * @param {*} where ：查询条件 
             */

            // sdb.getCount('integration',{})
            //     .then(function(result){
            //        return reply.data(result);
            //     }).catch(function(err){
            //        return reply.err('执行错误');
            //     });

        // 查询指定条数的数据
           /** 
             * 查询指定条数的数据
             * @param {*} collectionName ：集合名 eg 'integration'
             * @param {*} where ：查询条件 eg {}
             * @param {*} sort ：排序条件{field:-1} -1降序 1升序
             * @param {*} limit ：限制参数{skip:2,limit: 10}
             * 
             */

            // sdb.queryByLimtCount('integration',{},{create_date:-1},{limit:2})
            //     .then(function(result){
            //         return reply.data(result);
            //     }).catch(function(err){
            //        return reply.err('执行错误');
            //     });

        //根据查询条件，删除多个文档
            /**
             * 根据查询条件，删除多个文档
             * @param {*} collectionName ：集合名 
             * @param {*} where ：删除的查询条件
             * 
             */

            // sdb.removeAll('greetcards',{"fromName" : "千年123"})
            //     .then(function(result){
            //         return reply.data(result);
            //     }).catch(function(err){
            //         return reply.err('执行错误');
            //     });

        // (2)指定非默认数据库的query，insert，update，remove 方法
        // 配置中必须配置 "otherDB":["db1","db2"],下面demo已查live数据库为例子

        // insert方法
            // sdb.insert('board',{name:'cc',age:23,job:'project'},"live")
            //     .then(function(result){
            //         return reply.data(result);
            //     }).catch(function(err){
            //       
            //         return reply.err(err);
            //     });

        // query方法
            // sdb.query('board',{_id:"5950a8487819af2adc1aabd0"},"live")
            //    .then(function(result){
            //       return reply.data(result);
            //    }).catch(function(err){
            //       return reply.err('执行错误');
            //    })

        //update方法
            // sdb.update("board",'5950a8487819af2adc1aabd0',{name:'gg'},"live")
            //    .then(function(result){
            //       return reply.data(result);
            //    }).catch(function(err){
            //      console.log(err);
            //       return reply.err('执行错误');
            //    })
            
        //remove 方法
            // sdb.remove('board','5950a8487819af2adc1aabd0',"live")
            //    .then(function(result){
            //       return reply.data(result);
            //    }).catch(function(err){
            //       return reply.err('执行错误');
            //    })

        //分页查询
            /**
             * 分页查询
             * @param {*} collectionName ：集合名 eg "board"
             * @param {*} where ：查询条件 {}
             * @param {*} sort ：排序条件 {create_date:-1}
             * @param {*} pageParam ：分页参数 eg {pageNo:1,pageSize:10}
             * @param {*} dbName ：monodb的数据库名 eg "live"
             * 
             */
            // sdb.queryListPage('board',{},{create_date:-1},{pageNo:1,pageSize:10},"live")
            // .then(function(result){
                
            //      return reply.data(result);
            // }).catch(function(err){
               
            //     return reply.err('执行错误');
            // });
        
        
        //获取文档条数
            /**
             * 查询总数
             * @param {*} collectionName ：集合名
             * @param {*} where ：查询条件
             * @param {*} dbName ：monodb的数据库名
             * 
             */
            // sdb.getCount('board',{},'live')
            //     .then(function(result){
            //        return reply.data(result);
            //     }).catch(function(err){
            //        return reply.err('执行错误');
            //     });

        // 查询指定条数的数据
           /**
             *  查询指定条数的数据
             * @param {*} collectionName ：集合名 eg 'board'
             * @param {*} where ：查询条件 eg {}
             * @param {*} sort ：排序条件{field:-1} -1降序 1升序
             * @param {*} limit ：限制参数{skip:2,limit: 10}
             * @param {*} dbName ：monodb的数据库名 eg 'live'
             * 
             */

            // sdb.queryByLimtCount('board',{},{create_date:-1},{limit:2},'live')
            //     .then(function(result){
            //         return reply.data(result);
            //     }).catch(function(err){
            //         return reply.err('执行错误');
            //     });
        //根据查询条件，删除多个文档
            /**
             * 根据查询条件，删除多个文档
             * @param {*} collectionName ：集合名
             * @param {*} where ：删除的查询条件
             * @param {*} dbName ：monodb的数据库名
             * 
             */

            // sdb.removeAll('board',{'name' : '测试版块'},'live')
            //     .then(function(result){
            //         return reply.data(result);
            //     }).catch(function(err){
            //         return reply.err('执行错误');
            //     });
    }
}