let utils = require("../../kernel/util");
let config = require("../../kernel/config");
let useref = require("useref");

//35912 有个建议，在page里css和js压缩合并后的名字的定义在构建的时候可以检查报警下，有时候不小心两个文件的名字起重了会出问题
let concat_map = {};

module.exports = function (content) {
    let userefParse = useref(content.replace(/\r\n/ig, "\n"), {noconcat: false});//useref只认识LF的bug，需要再次转换一下分页符号
    content = userefParse[0];

    let result = userefParse[1];

    if(result){
        return Promise.all([processRES("js",result.js),processRES("css",result.css)]).then(function () {
            return content;
        });
    }else{
        return Promise.resolve(content);
    }
};

function processRES(type,files) {
    if(!files) return Promise.resolve();

    let distPromise = [];
    Object.keys(files).forEach(function (fileDist) {
        distPromise.push(new Promise(function (resolve,reject) {
            utils.log2("info","assemble.concat",fileDist);

            //35912 有个建议，在page里css和js压缩合并后的名字的定义在构建的时候可以检查报警下，有时候不小心两个文件的名字起重了会出问题
            //判断重复然后提示
            if(concat_map[fileDist]){
                utils.log2("warn","concat.dup",fileDist)
            }else{
                concat_map[fileDist] = files[fileDist].assets;
            }

            let targetContent = "";
            files[fileDist].assets.forEach(function (fileSrc) {
                fileSrc = utils.join(config.dist, fileSrc);
                if (utils.existsSync(fileSrc)){
                    targetContent += utils.readFileSync(fileSrc).toString() + "\n";
                }
            });

            utils.writeFile(utils.join(config.dist, fileDist), targetContent,function () {
                utils.log2("info","assemble.concat.success",fileDist);
                resolve();
            });
        }));
    });
    return Promise.all(distPromise);
}

module.exports.processConcatMap = function () {
    let map = concat_map;

    let fileDelPromise = [];
    Object.keys(map).forEach(function (key) {
        map[key].forEach(function (file) {
            fileDelPromise.push(new Promise(function (resolve) {
                utils.remove(`${config.dist}/${file}`,function () {
                    resolve();
                })
            }))
        })
    });

    return Promise.all(fileDelPromise);
};