/**
 * 环境重置
 */

let utils = require("../../kernel/util");
let config = require("../../kernel/config");

module.exports = function (options) {

    /**
     * 1. 环境重置与初始化
     */

    return new Promise(function (resolve) {
        // if(options.reset){
            utils.remove(config.dist,function () {
                utils.log2("info","dir.delete",config.dist);
                resolve();
            });
        // }else{
        //     resolve();
        // }
    }).then(function () {
        return new Promise(function (resolve) {
            utils.copy(config.src,config.dist,function () {
                utils.log2("info","dir.copy",config.src,config.dist);
                resolve();
            });
        })
    }).then(function () {
        return new Promise(function (resolve) {
            utils.glob("dist/html/page/*.{json,html}",function (err,files) {
                let moveFiles = [];

                files.forEach(function (file) {
                    moveFiles.push(new Promise(function (resolve) {
                        if(file.endsWith("json")){
                            let page = require(`${process.cwd()}/${file}`);

                            page.name = utils.parse(file).name;

                            //先判断工程目录里有没有模板文件
                            let pageTemplate = `${config.src}/html/page/page.template`;
                            if(!utils.existsSync(pageTemplate)){
                                pageTemplate = `${__dirname}/../../scaffold/page.template`;
                            }

                            let pageContent = require("./template").template(pageTemplate,{
                                page:page,
                                project:config
                            });

                            utils.writeFile(`${config.dist}/${utils.parse(file).name}.html`,pageContent,function () {
                                utils.log2("info","page.found",file);
                                resolve()
                            })
                        }else{
                            let dist = utils.join(config.dist, utils.parse(file).base); //搬迁所有的html/page下的文件到根目录
                            utils.move(file, dist,function () {
                                utils.log2("info","page.found",file);
                                resolve()
                            });
                        }
                    }))
                });

                return Promise.all(moveFiles).then(function () {
                    resolve();
                });
            });
        })
    });
};