let utils = require("../../kernel/util");
let config = require("../../kernel/config");

let res_uglify_map = {};
let UglifyJS = require('uglify-js');

module.exports = function ($) {
    return processRES($,"script","src").then(function () {
        return $.html();
    });
};

function processRES($,type,attr) {
    let resPromise = [];

    $(type).each(function (i, o) {
        let src = o.attribs[attr];

        if(!src) return;

        if (!res_uglify_map[src]
            && utils.existsSync(`${config.dist}/${src}`)
            //1. 44672 排除压缩的资源（选择不压缩在--product -p打包的时候，不压缩特定的资源	）
            && !(config.exclude&&config.exclude.uglify&&config.exclude.uglify.indexOf(src)>-1)) {
            res_uglify_map[src] = true;
            resPromise.push(new Promise(function (resolve) {
                utils.log2("info","assemble.uglify",src);
                utils.writeFile(`${config.dist}/${src}`,UglifyJS.minify(`${config.dist}/${src}`).code,function () {
                    utils.log2("info","assemble.uglify.success",src);
                    resolve();
                })
            }))
        }
    });

    return Promise.all(resPromise).catch(function (err) {
        console.log(err);
        return Promise.reject();
    });
}