let  prompt = require("prompt");
prompt.message = "Lighting".green;
prompt.delimiter = ":".green;

let  utils = require('../kernel/util');

exports.do = function (directory, options) {
    //88845 light的create指令增加-r --root参数指定生成路径
    if(options.root){
        if(!require("fs").existsSync(options.root)){
            require("fs").mkdirSync(options.root)
        }
        process.chdir(options.root)
    }

    //59978 【lighting】“light create –t”: 增加项目类型介绍
    if(options.list){
        console.log(`
当前工具版本：${require("../package").version.green}
当前支持的模板类型与说明：
api...........................服务端开发工程
app...........................整包上传app开发工程
jsn...........................jsnative技术开发app工程
light.........................light1.x版本应用开发工程
vue...........................light2.x版本应用开发工程
jsn-app.......................整包上传app开发工程,同是支持jsn
        `);

        return Promise.resolve();
    }


    let properties = {
        projectName: {
            description: "您的工程名字是什么?",
            default: "light"
        },
        ver: {
            description: "您的工程版本是什么?",
            default: "0.0.1"
        },
        des: {
            description: "请简单描述一下当前的工程：",
            default: "Just For Fun"
        }
    };

    //初始化信息
    options.projectName = options.projectName || directory;

    //补全未填充属性
    for (let k in properties) {
        if (options[k]) {
            delete properties[k];  
        }
    }

    //引导用户补全信息
    let promise = new Promise(function (resolve, reject) {
        prompt.get({
            properties: properties
        }, function(err, result) {
            // 参数设置完毕
            utils.extend(options, result);
            resolve()
        });
    });


    //按照模板初始化工程目录
    promise = promise.then(function () {
        return new Promise(function (resolve) {
            utils.copy(`${__dirname}/../scaffold/${options.type||'vue'}`, options.projectName, function(err) {
                resolve();
            });
        })
    });

    // //目录已经存在，且非强制删除
    // if (_.existsSync(options.name) && !options.force) {
    //     prompt.get({
    //         properties: {
    //             del: {
    //                 description: "指定目录已经存在，是否删除y/n（提示：删除后不可撤销）?".red,
    //                 default: "n"
    //             }
    //         }
    //     }, function(err, r) {
    //         if (r.del != "y" && r.del != "Y") {
    //             _.log("info", "指定目录已经存在，创建无法继续，请更话目录后重试！");
    //             process.exit(0);
    //         }
    //
    //         _.remove(options.name, function() {
    //             projectCb();
    //         });
    //     })
    // } else {
    //     projectCb();
    // }

    //文件替换
    promise = promise.then(function () {
        return new Promise(function (resolve) {
            utils.glob(`${options.projectName}/**/*.{json,js,html}`,function (err,files) {
                let promiseArr = [];

                files.forEach(function (file) {
                    promiseArr.push(new Promise(function (resolve) {
                        doReplace(file, {
                            name: options.projectName,
                            version: options.ver,
                            desc: options.des,
                            id:options.id||''
                        });
                    }).then(resolve))
                });
                return Promise.all(promiseArr).then(resolve);
            });
        })
    });

    function doReplace(file, op) {
        let content = utils.readFileSync(file).toString();

        // 59980		【lighting】“light create”: 增加App ID关联命令
        content = content.replace(/\$name\$/ig, op['name']);
        content = content.replace(/\$desc\$/ig, op['desc']);
        content = content.replace(/\$version\$/ig, op['version']);
        content = content.replace(/\$link_id\$/ig, op['id']);

        utils.writeFileSync(file, content);

        return Promise.resolve();
    }
    
};