let utils = require('../kernel/util'),
    cheerio = require('cheerio'),
    config = require("../kernel/config"),
    template = require(`./lib/${config.type||"light-0.1"}`);

/**
 * 代码生成
 * @param cmd
 * @param options
 */
exports.do = function (cmd, options) {
    let files = utils.glob.sync(`${config.src}/{html/page/*.html,*.html}`);

    files.forEach(function (file) {
        let $ = cheerio.load(utils.readFileSync(file), {
            recognizeSelfClosing: true
        });

        ["view","component"].forEach(function (type) {
            //共生成这两种类型的代码
            utils.forEach($(type),function (unit) {
                let attribs = unit.attribs;

                if(!attribs.ref){//非工程间资源依赖
                    // 处理资源生成
                    template.process(type,attribs);
                }
            })
        });

        if(template.processRegister){
            let views = [];
            $("view").each(function (i,view) {
                views.push(view.attribs);
            });
            template.processRegister(file,views)
        }
    });
    return Promise.resolve();
};