let shelljs = require('shelljs'),
    child_process = require('child_process'),
    fs = require('fs'),
    pluginsRoot = require("../kernel/config").pluginsRoot;

/**
 * 代码生成
 * @param cmd
 * @param options
 */
exports.do = function (cmd, options) {
    //安装插件
    var pluginList = [], works_p = [];
    var configFile = fs.readFileSync(`${process.cwd()}/package.json`).toString() || fs.readFileSync(`${process.cwd()}/project.json`).toString();
    pluginList = JSON.parse(configFile).plugins ? JSON.parse(configFile).plugins : [];
    if (pluginList.indexOf("type-vue") == -1) {
        pluginList.push("type-vue");
    }

    pluginList.forEach(function (plugin) {
        works_p.push(new Promise(function (resolve) {
            child_process.execSync(`npm -g --prefix=${pluginsRoot} --registry=https://registry.npm.taobao.org install -d lighting-plugin-${plugin}`, {
                silent: false,
                stdio: [0, 1, 2]
            });
            resolve()
        }))
    })
    Promise.all(works_p);


    //安装项目依赖
    var packageFileList = [`${process.cwd()}/package.json`, `${process.cwd()}/lib/package.json`];

    packageFileList.forEach(function (packageFile, index) {
        var moduleList = [];
        if (fs.existsSync(packageFile)) {
            moduleList = JSON.parse(fs.readFileSync(packageFile).toString()).dependencies;

            if (moduleList !== undefined) {
                let works_m = [], modules = [];
                for (var key in moduleList) {
                    modules.push(key);
                }
                if (index == 1) {
                    shelljs.cd(`${process.cwd()}/lib/`);
                }
                modules.forEach(function (m) {
                    works_m.push(new Promise(function (resolve) {
                        child_process.execSync(`npm --registry=https://registry.npm.taobao.org install -d ${m}`, {
                            silent: false,
                            stdio: [0, 1, 2]
                        });
                        resolve()
                    }))
                })
                Promise.all(works_m);
            }
        }
    })

    return Promise.resolve();
};