let utils = require('../../kernel/util');
let config = require('../../kernel/config');

let html = utils.template(`
<div id="<%=utils.camel(id,'/')%>" style="display:none;"></div>
`);

let js =  utils.template(`
/**
 * VIEW <%=utils.camel(id,'/')%>
 * @param  {[type]} $ [description]
 * @return {[type]}   [description]
 */
;(function(){
  App.<%=utils.camel(id,'/')%>View.wrap({
    beforeRender:function(){
      //TODO
      return true;
    },
    ready:function(){
      //TODO
    },
    afterUnRender:function(){
    }
  });
})();
`);

let register =   utils.template(`
App.registView("<%=utils.camel(id,'/')%>",new App.View({
  el:"#<%=utils.camel(id,'/')%>",
  model:new App.Model()
}),<%=home%>);
`);

let typedTemplate = {
    html,
    js
};

exports.process = function (type, options,file) {
    options.utils = utils;
    ["js","html"].forEach(function (fileType) {
        let file = `${config.src}/${fileType}/${type}/${options.id}.${fileType}`;

        if(utils.existsSync(file)){
            utils.log2("info","gen.file.exists",file)
        }else{
            utils.outputFileSync(file,typedTemplate[fileType](options));
            utils.log2("info","gen.file.success",file)
        }
    });
};

exports.processRegister = function (file,views) {
    let fileRegister = `${config.src}/js/regist/${utils.parse(file).name}.js`;
    //每次都要重新生成
    utils.removeSync(fileRegister);

    views.forEach(function (view) {
        view.home = view.home || false;
        if(!utils.existsSync(fileRegister)) {
            utils.outputFileSync(fileRegister, register(view));
        }else{
            utils.outputFileSync(fileRegister, register(view),{
                flag:"a"
            });
        }
    })
};