let utils = require('../../kernel/util');
let config = require('../../kernel/config');

let html = utils.template(`
<div id="<%=utils.camel(id,'/')%>" style="display:none;"></div>
`);

let js = utils.template(`
;(function(){
  App.defineViewModel("#<%=utils.camel(id,'/')%>",{
       data:{},
       watch:{},
       methods:{}
     },{
     ready:function(){
     },
     beforeRender:function (params) {
     },
     afterRender:function (params){
     },
     beforeUnRender:function (){
     },
     afterUnRender:function (){
     }
  });
})();
`);

let register =  utils.template(`
App.registerView({
    path:"/<%=view.id%>",
    el:"#<%=view.utils.camel(view.id,'/')%>",
    home:<%=view.home||'false'%><%if(view.parent){%>,
    parent:"#<%=view.utils.camel(view.parent,'/')%>"<%}%><%if(view.async){%>,
    async:"<%=view.async%>"<%}%>
});
`);

let component =  utils.template(`
;(function(win){
    let <%=utils.camel(id,'/')%> = new Light.Model({
        el: "#<%=utils.camel(id,'/')%>",
        data: {
        },
        methods: {
            init:function(){
                //init
            }
        }
    });
    win.<%=utils.camel(id,'/')%> = <%=utils.camel(id,'/')%>;
})(window);
`);

let typedTemplate = {
    view:{
        html,
        js
    },
    component:{
        html,
        component
    }
};

exports.process = function (type, options,file) {
    options.utils = utils;

    ["js","html"].forEach(function (fileType) {
        let file = `${config.src}/${fileType}/${type}/${options.id}.${fileType}`;

        if(utils.existsSync(file)){
            utils.log2("info","gen.file.exists",file)
        }else{
            utils.outputFileSync(file,typedTemplate[type][fileType](options));
            utils.log2("info","gen.file.success",file)
        }
    });
};

exports.processRegister = function (file,views) {
    let fileRegister = `${config.src}/js/regist/${utils.parse(file).name}.js`;
    //每次都要重新生成
    utils.removeSync(fileRegister);

    views.forEach(function (view) {
        view.utils = utils;
        if(!utils.existsSync(fileRegister)) {
            utils.outputFileSync(fileRegister, register({view}));
        }else{
            utils.outputFileSync(fileRegister, register({view}),{
                flag:"a"
            });
        }
    })
};