const prompt = require("prompt");
const authStore = require("../kernel/config").authStore;

exports.do = function (cmd, options) {

    let promise = new Promise(function (resolve, reject) {
        //检查当前是否已经登录了账户并提示用户
        require("fs").readFile(authStore,function (err, data) {
            if(!err){
                require("../kernel/util").log("info",`已经登录账户：${JSON.parse(data).nickName}`);
            }
            resolve()
        });
    });

    promise = promise.then(function () {
        //引导用户输入用户名和密码
        const schema = {
            properties: {
            }
        };

        if(!options.userName){
            schema.properties.userName = {
                description: "请输入用户名?",
                required: true
            }
        }

        if(!options.password){
            schema.properties.password = {
                description: "请输入登录密码?",
                hidden: true,
                required: true
            }
        }

        if(Object.keys(schema.properties).length>0){
            return new Promise(function (resolve,reject) {
                prompt.start();
                prompt.get(schema, function (err, result) {
                    if(!err){
                        require("lodash").extend(options,result)
                        resolve(options);
                    }else{
                        reject("必须输入用户名和密码！");
                    }
                });
            })
        }else{
            return options;
        }
    });


    promise = promise.then(function (user) {
        // 开始登录流程
        return new Promise(function (resolve, reject) {
            require("request").post('https://light.hscloud.cn/portal/sys/login/light.json', {
                form:{
                    skey:new Buffer(JSON.stringify({
                        "passwd":user.password,
                        "account":user.userName,
                    })).toString("base64"),
                    deviceUid:require("node-machine-id").machineIdSync()
                }
            },function (err, httpResponse, body) {
                if(!err){
                    const resInfo = JSON.parse(body)

                    if(resInfo.error_info){
                        reject(resInfo.error_info)
                    }else{
                        resolve(resInfo)
                    }
                }
            })
        })
    });

    //保存用户信息
    promise = promise.then(function (user) {
        require("fs").writeFileSync(authStore,JSON.stringify({
            long_token:user.long_token,
            auth_id:user.auth_id,
            nickName:user.user.nickName,
            deviceUid:require("node-machine-id").machineIdSync()
        }));
        return user;
    });

    promise = promise.then(function (user) {
        require("../kernel/util").log("info",`${user.user.nickName}登录成功，欢迎归来！`);
    });

    promise.catch(function (err) {
        require("../kernel/util").log("info",err);
    })
};