let child_process = require('child_process'),
	_ = require("../kernel/util"),
    os = require("os"),
	pluginsDir = require("../kernel/config").pluginsDir,
    pluginsRoot = require("../kernel/config").pluginsRoot,
    fs = require("fs");;

exports.do = function(cmd,options) {
	if(!_.existsSync(pluginsDir)){
        _.mkdirsSync(pluginsDir);

        //35820 mac下有个bug，要手动删除一下$HOME/.lighting-plugins/lib这个目录
        _.mkdirsSync(_.join(pluginsDir,"node_modules"));
	}

	if(options.add || options.upgrade){

	    let promise = new Promise(function (resolve, reject) {
            let command,plugin;
            if(options.add){
                plugin = [options.add.replace("lighting-plugin-","")];
                command = "install";
                resolve([command,plugin])
            }
            if(options.upgrade){
                command = "update";
                if(options.upgrade===true){
                    fs.readdir(`${pluginsDir}/node_modules`,function (err,dirs) {
                        plugin = [];
                        dirs.forEach(function (dir) {
                            if(dir.startsWith("lighting-plugin-") &&fs.existsSync(`${pluginsDir}/node_modules/${dir}/package.json`)){
                                plugin.push(dir.match(/^lighting-plugin-(.*)$/)[1])
                            }
                        });
                        resolve([command,plugin]);
                    });
                }else{
                    plugin = [options.upgrade.replace("lighting-plugin-","")];
                    resolve([command,plugin])
                }
            }
        });

	    promise.then(function (data) {
            let works = [],
                [command,plugins] = data;

            plugins.forEach(function (plugin) {
                works.push(new Promise(function (resolve) {
                    // 添加插件
                    child_process.execSync(`npm -g --prefix=${pluginsRoot} --registry=https://registry.npm.taobao.org ${command} -d lighting-plugin-${plugin}`, {
                        silent: false,
                        stdio:[0,1,2]
                    });

                    //增加安装插件的提示，以防止太长时间的等待而无反应
                    resolve()
                }))
            });

            Promise.all(works);
        });
    }
    
  
	if(options.remove){
        _.remove(`${pluginsDir}/node_modules/lighting-plugin-${options.remove}`,function () {
			_.log2("info","plugin.remove",options.remove)
        });
	}

	if(options.fix){
        Promise.all([
            new Promise(function (resolve) {
                //初始化插件安装环境
                _.remove(pluginsDir, function () {
                    // _.mkdirp(`${pluginsDir}/node_modules`,function () {
                    _.log2("info", "plugin.fix")
                    resolve();
                    // })
                })
            }),
            new Promise(function (resolve) {
                let cache_path = child_process.execSync('npm config get cache').toString().trim();
                _.remove(cache_path,function () {
                    _.log("info", "npm缓存目录清除成功!");
                    resolve();
                });
            })
        ])
	}

	if(options.list){
        fs.readdir(`${pluginsDir}/node_modules`,function (err,dirs) {
            if(err) {
                console.log(err);
            } else {
                dirs.forEach(function (dir) {
                    if(dir.startsWith("lighting-plugin-") &&fs.existsSync(`${pluginsDir}/node_modules/${dir}/package.json`)){
                        fs.readFile(`${pluginsDir}/node_modules/${dir}/package.json`,function (err,data) {
                            console.log(`${dir.green}:${JSON.parse(data.toString()).version.white}`)
                        })
                    }
                })
            }
        })
    }
};