const express = require("express");

exports.do = function(cmd,options,cb) {
    const light = require('../kernel'),
		_ = light.util;

	options = _.merge({
		port:3000,
		root:process.cwd()
	},options);

	if(options.debug){
        light.options = options;
		//检查当前环境下是否存在debug插件
        require("./build/plugin")({
            enablePlugins:['debug']
		}).then(function () {
            return require("./build/plugin").runStage("prepare")
        }).then(function () {
            return require("./build/plugin").runStage("debug")
        }).then(function () {
            _.log("info",`HTTP服务器正常启动 Listening at http://${_.getIPAdress()}:` + (+options.port+1000));
            _.openURL(`http://${_.getIPAdress()}:${+options.port+1000}`);
        })
	}else{
        const app = express();
        app.use(express.static(options.root));

        const http = require('http').Server(app);
        http.listen(options.port,function () {
            _.log("info",`HTTP服务器正常启动 Listening at http://${_.getIPAdress()}:${options.port}`);
            _.openURL(`http://${_.getIPAdress()}:${options.port}`);

            if(cb) cb.call(null,http);
        });
	}
};